=== debian/changelog ===
stepmania (5.0.12+dfsg-2~mx15+1) mx; urgency=medium

  * Rebuild for MX 15.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 27 Aug 2019 18:45:01 -0700

stepmania (5.0.12+dfsg-2build3) disco; urgency=low

  * Rebuild for Disco

 -- kakurasan <kakurasan@gmail.com>  Sat, 20 Apr 2019 22:30:00 +0900

stepmania (5.0.12+dfsg-2build2) cosmic; urgency=low

  * Rebuild for Cosmic

 -- kakurasan <kakurasan@gmail.com>  Mon, 22 Oct 2018 22:30:00 +0900

stepmania (5.0.12+dfsg-2build1) bionic; urgency=low

  * Rebuild for Bionic

 -- kakurasan <kakurasan@gmail.com>  Fri, 27 Apr 2018 23:00:00 +0900

stepmania (5.0.12+dfsg-2) artful; urgency=low

  * Add stepmania-5.0.12-messageman.patch
    from https://github.com/stepmania/stepmania/pull/1384
    See also: https://github.com/stepmania/stepmania/issues/1606#issuecomment-359112386
  * Use default GCC

 -- kakurasan <kakurasan@gmail.com>  Fri, 27 Apr 2018 22:00:00 +0900

stepmania (5.0.12+dfsg-1build2) artful; urgency=low

  * Rebuild for Artful

 -- kakurasan <kakurasan@gmail.com>  Fri, 13 Oct 2017 22:00:00 +0900

stepmania (5.0.12+dfsg-1build1) zesty; urgency=low

  * Rebuild for Zesty

 -- kakurasan <kakurasan@gmail.com>  Sat, 22 Apr 2017 22:00:00 +0900

stepmania (5.0.12+dfsg-1) yakkety; urgency=low

  * New upstream release
  * Use GCC5

 -- kakurasan <kakurasan@gmail.com>  Thu, 27 Oct 2016 22:00:00 +0900

stepmania (5.0.11+dfsg-1) xenial; urgency=low

  * New upstream release

 -- kakurasan <kakurasan@gmail.com>  Thu, 16 Jun 2016 22:00:00 +0900

stepmania (5.0.9+dfsg-3) xenial; urgency=low

  * Fix dep5-copyright-license-name-not-unique

 -- kakurasan <kakurasan@gmail.com>  Mon, 11 Apr 2016 22:00:00 +0900

stepmania (5.0.9+dfsg-2build1) wily; urgency=low

  * Rebuild for Wily

 -- kakurasan <kakurasan@gmail.com>  Sat, 10 Oct 2015 22:00:00 +0900

stepmania (5.0.9+dfsg-2) vivid; urgency=low

  * Fix build failure on i386

 -- kakurasan <kakurasan@gmail.com>  Tue, 23 Jun 2015 22:00:00 +0900

stepmania (5.0.9+dfsg-1) vivid; urgency=low

  * New upstream release

 -- kakurasan <kakurasan@gmail.com>  Mon, 22 Jun 2015 22:00:00 +0900

stepmania (5.0.8+dfsg-1) vivid; urgency=low

  * New upstream release
  * Use CMake

 -- kakurasan <kakurasan@gmail.com>  Tue, 12 May 2015 22:00:00 +0900

stepmania (5.0.7+dfsg-1) vivid; urgency=low

  * Initial release (version 5)

 -- kakurasan <kakurasan@gmail.com>  Sun, 12 Apr 2015 22:00:00 +0900
