=== debian/control ===
Source: stepmania
Section: games
Priority: extra
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: kakurasan <kakurasan@gmail.com>
Build-Depends: cmake,
               debhelper (>= 9),
               libasound2-dev,
               libbz2-dev,
               libgl1-mesa-dev,
               libgles2-mesa-dev,
               libglew-dev,
               libglu1-mesa-dev,
               libgtk2.0-dev,
               libjack-jackd2-dev,
               libjpeg-dev,
               libmad0-dev,
               libogg-dev,
               libpcre3-dev,
               libpng-dev,
               libpulse-dev,
               libudev-dev,
               libva-dev,
               libvorbis-dev,
               libxrandr-dev,
               libxtst-dev,
               yasm,
               zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://www.stepmania.com/

Package: stepmania
Architecture: any
Depends: stepmania-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Advanced rhythm game
 StepMania is a music/rhythm game. The player presses different buttons in time
 to the music and to note patterns that scroll across the screen. Features 3D
 graphics, visualizations, support for gamepads/dance pads, a step recording
 mode, and more!
 To add songs, simply copy the content of your folder containing songs to
 ~/.stepmania-5.0/Songs as user, or to /usr/share/games/stepmania/Songs as root.

Package: stepmania-data
Architecture: all
Depends: ${misc:Depends}
Description: Advanced rhythm game - data files
 StepMania is a free dance and rhythm game. It features 3D
 graphics, keyboard and "dance pad" support, and an editor for creating
 your own steps.

Package: stepmania-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Advanced rhythm game - doc files
 StepMania is a free dance and rhythm game. It features 3D
 graphics, keyboard and "dance pad" support, and an editor for creating
 your own steps.
